//made by skmskm(Michał Kohlman)
//For car robot
#include <Servo.h>

Servo Kola;
Servo Czujnik;
Servo lewy_naped;
Servo prawy_naped;

#define Tiger 32
#define Echo 34

unsigned long time_wait = 0;
bool updated_sensor = false;

void setup() {
  // put your setup code here, to run once:
  Kola.attach(2);
  Czujnik.attach(3);
  lewy_naped.attach(6);
  prawy_naped.attach(7);

  Czujnik.write(0);
  lewy_naped.write(90);
  prawy_naped.write(85);//85

    pinMode(Tiger,          OUTPUT);
  pinMode(Echo,           INPUT );  
  Update_Movment();
}

float SensorRead()
{
  digitalWrite(Tiger, HIGH);
  delayMicroseconds(10);
  digitalWrite(Tiger, LOW);
  unsigned long duration = pulseIn(Echo, HIGH,100*58);//limited to 80 cm
  float wynik = ((float)duration)/58.2F;
  if( wynik <= 1 )
    return 100;
  return wynik;
}

int Sensor_State = 0;
float Sensor_Data[7];//readings from 5 directions
bool Ready_To_Start = false;
unsigned long Sensor_time = 0;

enum Direction{
  Left = 0,
  Right = 2,
  Front = 1
};

enum Speed{
  Foard = 0,
  Stop = 1,
  Back = 2
};

Direction Car_Dir = Front;
Speed     Car_State = Stop;
Direction Sensor_Dir = Front;
bool go_back = false;


void Scan_Update()
{
  if( (millis() - Sensor_time) > 150 + (( go_back )?(6-2*((Sensor_Dir == Left)?1:0)-Sensor_State)*75:
  0) )
  {
    go_back = false;
    Sensor_time = millis();
    Sensor_Data[Sensor_State] = SensorRead();
    Sensor_State++;
    if( Sensor_State >= 7-2*((Sensor_Dir == Left)?1:0) )
    {
      Sensor_State = 2*((Sensor_Dir == Right)?1:0);
      if( Sensor_Dir == Right )
      {
        Sensor_Data[0] = 80;
        Sensor_Data[1] = 80;
      }
      if( Sensor_Dir == Left )
      {
        Sensor_Data[5] = 80;
        Sensor_Data[6] = 80;
      }
      go_back = true;
    }
    switch( Sensor_State )
    {
    case 0:
      Czujnik.write(15);
      break;
    case 1:
      Czujnik.write(40);
      break;
    case 2:
      Czujnik.write(80);
      break;
    case 3:
      Czujnik.write(90);
      break;
    case 4:
      Czujnik.write(110);
      break;
    case 5:
      Czujnik.write(150);
      break;
    case 6:
      Czujnik.write(180);
      break;
    }
  }
}

void Update_Movment()
{
  switch( Car_Dir )
  {
  case Front:
    Kola.write(80);
    break;
  case Left:
    Kola.write(95);
    break;
  case Right:
    Kola.write(60);
    break;
  }
  if( Car_Dir == Left )
  {
    switch( Car_State )
    {
    case Foard:
      lewy_naped.write(45);
      prawy_naped.write(180);
      break;
    case Stop:
      lewy_naped.write(88);
      prawy_naped.write(86);
      break;
    case Back:
      lewy_naped.write(135);
      prawy_naped.write(0);
      break;
    }
  }
  if( Car_Dir == Right )
  {
    switch( Car_State )
    {
    case Foard:
      lewy_naped.write(0);
      prawy_naped.write(135);
      break;
    case Stop:
      lewy_naped.write(88);
      prawy_naped.write(86);
      break;
    case Back:
      lewy_naped.write(180);
      prawy_naped.write(45);
      break;
    }
  }
  if( Car_Dir == Front )
  {
    switch( Car_State )
    {
    case Foard:
      lewy_naped.write(0);
      prawy_naped.write(180);
      break;
    case Stop:
      lewy_naped.write(88);
      prawy_naped.write(86);
      break;
    case Back:
      lewy_naped.write(180);
      prawy_naped.write(0);
      break;
    }
  }
}

bool back_started = false;
int dest_Wall = 30;
int dest_Wall_max = 40;

void loop() {
  Scan_Update();
  //now do AI stuff
  Car_Dir = Front;
  Sensor_Dir = Front;
  if( Car_State == Foard )
    if( Sensor_Data[0] < dest_Wall && Sensor_Data[1] < dest_Wall )
    {
      Sensor_Dir = Left;
      Car_Dir = Right;
    }
    else
      if( Sensor_Data[6] < dest_Wall && Sensor_Data[5] < dest_Wall )
      {
        Sensor_Dir = Right;
        Car_Dir = Left;
      }
      else
        if( ( Sensor_Data[0] > dest_Wall && Sensor_Data[1] > dest_Wall && Sensor_Data[0] < dest_Wall_max ) || ( Sensor_Data[1] > dest_Wall && Sensor_Data[1] < dest_Wall_max ))
        {
          Sensor_Dir = Left;
          Car_Dir = Left;
        }
        else
          if( ( Sensor_Data[6] > dest_Wall && Sensor_Data[5] > dest_Wall && Sensor_Data[6] < dest_Wall_max ) || ( Sensor_Data[5] > dest_Wall && Sensor_Data[5] < dest_Wall_max ))
          {
            Sensor_Dir = Right;
            Car_Dir = Right;
          }
  if( Car_State == Back )
    if( Sensor_Data[0] < dest_Wall && Sensor_Data[1] < dest_Wall )
    {
      Sensor_Dir = Left;
      Car_Dir = Left;
    }
    else
      if( Sensor_Data[6] < dest_Wall && Sensor_Data[5] < dest_Wall )
      {
        Sensor_Dir = Right;
        Car_Dir = Right;
      }
      else
        if( ( Sensor_Data[0] > dest_Wall && Sensor_Data[1] > dest_Wall && Sensor_Data[0] < dest_Wall_max ) || ( Sensor_Data[1] > dest_Wall && Sensor_Data[1] < dest_Wall_max ))
        {
          Sensor_Dir = Left;
          Car_Dir = Right;
        }
        else
          if( ( Sensor_Data[6] > dest_Wall && Sensor_Data[5] > dest_Wall && Sensor_Data[6] < dest_Wall_max ) || ( Sensor_Data[5] > dest_Wall && Sensor_Data[5] < dest_Wall_max ))
          {
            Sensor_Dir = Right;
            Car_Dir = Left;
          }
  if( !back_started && (Sensor_Data[2] < 30 || Sensor_Data[3] < 30 || Sensor_Data[4] < 30 ))
  {
    Car_State = Back;
    back_started = true;
  }
  if( back_started && !( Sensor_Data[2] > 50 || Sensor_Data[3] > 50 || Sensor_Data[4] > 50 ))
  {
    if( Car_Dir == Front )
    {
      Sensor_Dir = Right;
      Car_Dir = Right;
    }
  }
  if( back_started && ( Sensor_Data[2] > 50 || Sensor_Data[3] > 50 || Sensor_Data[4] > 50 ))
  {
    Car_State = Foard;
    back_started = false;
  }

  Update_Movment();
}











